import { PoolOptions, OkPacket } from 'mysql2';
import { SlimNodeMySQLPool } from './SlimNodeMySQLPool';
export type PreparedStatementParameters = Record<string, unknown>;
export declare class SlimNodeMySQL {
    protected pool: SlimNodeMySQLPool;
    constructor(config: string | PoolOptions, connectionLimit?: number);
    execute(sql: string, parameters?: PreparedStatementParameters): Promise<OkPacket>;
    query<TableModel>(sql: string, parameters?: PreparedStatementParameters): Promise<TableModel[]>;
    getOne<TableModel>(sql: string, parameters?: PreparedStatementParameters): Promise<TableModel>;
    getValue<TableModel, K extends keyof TableModel>(column: K, sql: string, parameters?: PreparedStatementParameters): Promise<TableModel[K] | null>;
    exists<TableModel>(sql: string, parameters?: PreparedStatementParameters): Promise<boolean>;
    close(): void;
}
